angular.module('beamng.apps')
	// register service
	.factory('VehicleService', function() {
		var vehicleName = "";
		return {
			getVehicleName: function()        				{ return vehicleName;           },
			setVehicleName: function(newVehicleName) 	{ 
				vehicleName = newVehicleName.replace(/_/gi," ")
				},
		};
	})
	.directive('vehicleName', ['bngApi', 'StreamsManager', 'UiUnits', 'VehicleService', function (bngApi, StreamsManager, UiUnits, VehicleService) {
		return {
			template:
        '<div style="width:100%; height:100%;" layout="column" layout-align="center center" class="bngApp">' +
          '<span style="font-size:1.3em; text-align:center; text-transform: capitalize;" > Current Vehicle: {{ vehicleName }}</span>' +
        '</div>',
			replace: true,
			link:
			function (scope, element, attrs) {
				// assign vehicleName to currently stored value in VehicleService
				scope.vehicleName = VehicleService.getVehicleName();

				scope.$on("VehicleChange", function(event, data) {
					// get current vehicle
					bngApi.engineLua("core_vehicles.getCurrentVehicleDetails()", function(vehicle) {
						scope.$evalAsync(function() {
							// save current vehicle key
							VehicleService.setVehicleName(vehicle.current.key);
							scope.vehicleName = VehicleService.getVehicleName();
						})
					})
				})
			}
		};
	}])
